setBCs; 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
rhoold = rho; 
rhoUold = rhoU; rhoVold = rhoV; 
Uold = rhoU./rho; Vold = rhoV./rho;
rhoEold = rhoE; rhoCold = rhoC; 

rhoc    = rho; rhoCc = rhoC;
rhoUc   = rhoU; rhoVc   = rhoV;
rhoEc   = rhoE; 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
ConstructIncrements; 
rho = rhoold +0.5*drho;
rhoU= rhoUold+0.5*drhoU;
rhoV= rhoVold+0.5*drhoV;
rhoE= rhoEold+0.5*drhoE;
rhoC= rhoCold+0.5*drhoC;

U=rhoU./rho; V=rhoV./rho; 
T=((rhoE-0.5*rho.*(U.^2 + V.^2))/Cv)./rho;
p=R*rho.*T; C = min(1, max(0, rhoC./rho));
setBCs; 

rhoc  = rhoc  + a1*drho; 
rhoUc = rhoUc + a1*drhoU; 
rhoVc = rhoVc + a1*drhoV; 
rhoEc = rhoEc + a1*drhoE;
rhoCc = rhoCc + a1*drhoC;

ConstructIncrements;
rho = rhoold +0.5*drho;
rhoU= rhoUold+0.5*drhoU;
rhoV= rhoVold+0.5*drhoV;
rhoE= rhoEold+0.5*drhoE;
rhoC= rhoCold + 0.5*drhoC;

U=rhoU./rho; V=rhoV./rho; 
T=((rhoE-0.5*rho.*(U.^2 + V.^2))/Cv)./rho;
p=R*rho.*T; C = min(1, max(0, rhoC./rho));
setBCs; 

rhoc  = rhoc  + a2*drho; 
rhoUc = rhoUc + a2*drhoU;
rhoVc = rhoVc + a2*drhoV; 
rhoEc = rhoEc + a2*drhoE;
rhoCc= rhoCc + a2*drhoC;

ConstructIncrements;
rho = rhoold +drho;
rhoU= rhoUold+drhoU;
rhoV= rhoVold+drhoV;
rhoE= rhoEold+drhoE;
rhoC= rhoCold + drhoC;

U=rhoU./rho; V=rhoV./rho; 
T=((rhoE-0.5*rho.*(U.^2 + V.^2))/Cv)./rho;
p=rho.*R.*T; C = min(1, max(0, rhoC./rho));
setBCs; 

rhoc  = rhoc  + a3*drho; 
rhoUc = rhoUc + a3*drhoU; 
rhoVc = rhoVc + a3*drhoV; 
rhoEc = rhoEc + a3*drhoE;
rhoCc = rhoCc + a3*drhoC;

ConstructIncrements;

rhoc  = rhoc  + a4*drho; 
rhoUc = rhoUc + a4*drhoU; 
rhoVc = rhoVc + a4*drhoV; 
rhoEc = rhoEc + a4*drhoE;
rhoCc = rhoCc + a4*drhoC;

rho = rhoc;
rhoU= rhoUc;
rhoV= rhoVc;
rhoE= rhoEc;
U=rhoU./rho; V=rhoV./rho; 
%
T=((rhoE-0.5*rho.*(U.^2 + V.^2))/Cv)./rho; 
p=R*rho.*T; C = min(1, max(0, rhoC./rho));
rhoC = rhoCc;

setBCs; 

