Cv = 717.5;  % specific heat of Nitrogen
R  = 287;    % gas constant
Cp = R + Cv; % specific heat at constant pressure
gamma = Cp/Cv; % adiabatic constant

%    nu = 0.0063;
if(mycase == 0)
nu  = Allnu(jjj);
nuT = nu;
Tb  = 1000; Tu = 500;  rhou = 0.35;
pu = rhou*R*Tu; % in Pascals  
Slam = AllSlam(iii);
Djet = 0.001; % diameter of the jet in m
Ma   = AllMa(kkk); % Curvature switch 


elseif(mycase > 0)
nu  = Allnu(jjj); %  kinematic viscosity m^2/s 
nuT = nu;
rhou = 0.35; 
Tb  = 1000; Tu = 500;  
pu = rhou*R*Tu; % in Pascals  
                
Slam = AllSlam(iii); 
Djet = 0.001; % diameter of the jet in m

Ma   = AllMa(kkk); % Curvature switch 

end