% kappa = -1/|grad(C)| ( laplacia(C) - n dot grad( |grad(C)| )
knyq = (2*pi/(2*dx)); 

%CC = C + (1/knyq^2)*laplacian(C,d2dx2,d2dy2); 

dCdx = gradX(C,ddx);    dCdy = gradY(C,ddy); 
dCdx2= gradXX(C,d2dx2); dCdy2= gradYY(C,d2dy2);
gradC = sqrt(dCdx.^2 + dCdy.^2); gradCsqr = gradC.^2;
dCdxdy = gradX(gradY(C,ddy),ddx);

cosa = (dCdx)./max(1e-20, gradC); sina =  (dCdy)./max(1e-20, gradC);

kappa = -( (sina.^2).*dCdx2 + (cosa.^2).*dCdy2 - 2*cosa.*sina.* ...
           dCdxdy); 
%kappa(1:10,:)=0;
kappa = kappa + (1/knyq^2)*laplacian(kappa,d2dx2,d2dy2); 
