knyq = (2*pi/(2*dx)); 

%jump = 0.5*(1+tanh(  (gradC - 1/(5*dx))/(2*dx) )); 
jump = C.*(1-C);

rho = rho - (1/knyq^4)*laplacian(laplacian(rho,d2dx2,d2dy2),d2dx2,d2dy2); 
rhoU = rhoU - (1/knyq^4)*laplacian(laplacian(rhoU,d2dx2,d2dy2), ...
                                   d2dx2,d2dy2); 
rhoV = rhoV - (1/knyq^4)*laplacian(laplacian(rhoV,d2dx2,d2dy2), ...
                                   d2dx2,d2dy2); 
rhoE = rhoE - (1/knyq^4)*laplacian(laplacian(rhoE,d2dx2,d2dy2), ...
                                   d2dx2,d2dy2); 
rhoC = rhoC - (1/knyq^4)*laplacian(laplacian(rhoC,d2dx2,d2dy2), ...
                                   d2dx2,d2dy2); 

 
rho = rho + (1/knyq^2)*divgrad(jump, rho,ddx,ddy,d2dx2,d2dy2);
rhoU = rhoU + (1/knyq^2)*divgrad(jump, rhoU,ddx,ddy,d2dx2,d2dy2);
rhoV = rhoV + (1/knyq^2)*divgrad(jump, rhoV,ddx,ddy,d2dx2,d2dy2);
rhoE = rhoE + (1/knyq^2)*divgrad(jump, rhoE,ddx,ddy,d2dx2,d2dy2);
rhoC = rhoC + (1/knyq^2)*divgrad(jump, rhoC,ddx,ddy,d2dx2,d2dy2);

% possibility to further use 2nd order filter on p and T
%p = p + (1/knyq^2)*laplacian(p,d2dx2,d2dy2); 
%T = T + (1/knyq^2)*laplacian(T,d2dx2,d2dy2); 

U=rhoU./rho; V=rhoV./rho; C=rhoC./rho;  C = min(1, max(0, C));
%
T=((rhoE-0.5*rho.*(U.^2 + V.^2))/Cv)./rho;
p=R*rho.*T; 


setBCs; 