Ekin(t) = 0.5*sum(sum((U.^2 + V.^2)*dx*dx))/(Lx*Ly);

dudx = (real(ifft2( i*KX.*fft2(U)))); dudy = (real(ifft2( i*KY.*fft2(U)))); 
dvdx = (real(ifft2( i*KX.*fft2(V)))); dvdy = (real(ifft2( i*KY.*fft2(V)))); 

Diss(t) = nu*sum(sum((dudx.^2 + dudy.^2 + dvdx.^2 + dvdy.^2)*dx*dx))/(Lx*Ly);

ComputeDrag;
Cds(t) = Cd;
if(mod(t,20)==0)
figure(5), clf
plot(linspace(0,t,length(Cds))*dt, abs(Cds)), hold on
%Re = (Umax)*2*rc/nu;
Re = Umaxmax*2*rc/nu;
plot([0,t]*dt,ones(1,2)*(1+10/Re^(2/3)),'r-','Linewidth',2)
%plot([0,t],ones(1,2)*24/(Umax*2*rc/nu),'r-','Linewidth',2)
title(strcat('Error=', num2str(Cd-24/(Umax*2*rc/nu))))
axis([0,(t+5)*dt,0,10]),drawnow

figure(6), clf
dTdx = real(ifft2(i*KX.*fft2(Tmax-T)));
Nu   = dTdx/( ( (Tmax-Tmin)/(2*rc)));
plot(X(Ny/2,:), abs(Nu(Ny/2,:)), 'r-','Linewidth',2)
title('Nusselt number')
axis([0,Lx,0,30]),drawnow
end
