fprintf('-----------------------------------------------------------------')
fprintf('\n')
fprintf(['Fire, a two-dimensional finite difference solver by V.Vuorinen'])
fprintf('\n')
fprintf('Dept. of Mech. Eng. Technology, Aalto University, Finland') 
fprintf('\n')
display('Using fractional step RK4 method.')
fprintf('\n')
display(strcat('Reynolds number is: ', num2str( Vmax*Djet/nu) ))
%fprintf('\n')
display(strcat('Courant number (stability Co << 1): ', num2str( (Vmax+sqrt(max(max(R*T))))*dt/dx)))
%fprintf('\n')
display(strcat(['Courant-Friedrichs-Lewy number (stability CFL << 1): '], num2str( dt*nu/(dx*dx))))
%fprintf('\n')
display(strcat('Prandtl number: ', num2str( nu/nuT) ))

fprintf('------------------------------------------------------------------')
fprintf('\n')
