if(mycase == 0) 

   C  = 1-exp( - ( (X-Lx/2).^2 + (Y-Ly/2).^2)/(2*(Lx/15)^2)); rhoC= rho.*C;

   T    = (1-C)*Tb+ (C)*Tu;
   rho  = (1-C)*rhou*(Tu/Tb) + C*rhou; 
   p    = rho.*T*R;   % setting pressure

   kmax = 2*pi*8/Lx; kmaxy=2*pi*8/Ly;
   U  = -Vmax*cos(kmax*X).*sin(kmaxy*Y);  V = Vmax*sin(kmax*X).*cos(kmaxy*Y);
   U  = -Vmax*cos(kmax*X.*V).*sin(kmaxy*Y.*U);  V = Vmax*sin(kmax*X.*U).*cos(kmaxy*Y.*V);

   
   rhoU = rho.*U;              % initializing rhoU and rhoE
   rhoE = Cv*rho.*T + 0.5*rho.*(U.^2 + V.^2); 

elseif(mycase == 1) 
   zeroGradWallT=1; zeroGradOutletU = 1; zeroGradOutletT = 1;  
      
   rho  = (rhou*(Tu/Tb))*ones(Ny,Nx);
   p   = (rhou*Tu*R)*ones(Ny,Nx);   % setting pressure
   T = Tb*ones(Ny,Nx);             % temperature from the equation of state p=rho*R*T

   rhoU = rho.*U;              % initializing rhoU and rhoE
   rhoE = Cv*rho.*T + 0.5*rho.*(U.^2 + V.^2); 

   setBCs;

elseif(mycase == 2)
    zeroGradWallT=1; zeroGradOutletU = 1; zeroGradOutletT = 1;  

    rho  = rhou*ones(Ny,Nx);
    p   = pu*ones(Ny,Nx);   % setting pressure
    T = (p./rho)/R;             % temperature from the equation of state p=rho*R*T

    rhoU = rho.*U;              % initializing rhoU and rhoE
    rhoE = Cv*rho.*T + 0.5*rho.*(U.^2 + V.^2); 

    setBCs;
    
elseif(mycase == 3)
    zeroGradWallT=1; zeroGradOutletU = 1; zeroGradOutletT = 1;  

    rho  = rhou*ones(Ny,Nx);
    p   = pu*ones(Ny,Nx);   % setting pressure
    T = (p./rho)/R;             % temperature from the equation of state p=rho*R*T

    rhoU = rho.*U;              % initializing rhoU and rhoE
    rhoE = Cv*rho.*T + 0.5*rho.*(U.^2 + V.^2); 

    setBCs;    
    
end