
if(mycase == 0)
Nx          = 2^8; 
Ny          = 2^8; 
dt          = 0.0000001; % timestep
Lx          = 4*pi*1e-3;    % domain side length
Ly          = 4*pi*1e-3;    % domain side length
else
Nx          = 2^7; 
Ny          = 2^7; 
dt          = 0.0000002; % timestep
Lx          = 4*pi*1e-3;    % domain side length
Ly          = 4*pi*1e-3;    % domain side length
end


dx = Lx/Nx;     % grid spacing dx
dy = Ly/Ny;     % grid spacing dy

simutimeSeconds = 1;
simutimeSteps   = round(simutimeSeconds/dt); % how many timesteps altogether
visualize       = 1; % set 0 for speed-up   

%%%%%%%%%%%%%%%%%%%%
% create the 2D grid
%%%%%%%%%%%%%%%%%%%%
x = (Lx-dx)*(0:(Nx-1))/(Nx-1); % to be precise, dx is subtracted here 
y = (Ly-dy)*(0:(Ny-1))/(Ny-1); % otherwise the derivative of e.g. sin(x) wouldnt be differentiable on this periodic grid
[X,Y] = meshgrid(x,y);     
