Tave(t) = mean(mean(T));

HowOftenVisu = 100; 
if(mod(t,HowOftenVisu)==0)
    
    qinx = 2:4:(Nx-2);     qiny = 2:4:(Ny-10); 
    
    
    GhiasData; 

    %   figure(1), clf, box
    %imagesc([0 Lx],[0 Ly],U(iny,inx)), colormap jet, shading flat
    %pause(0.1)
    %hold on

    %    figure(2), clf, box
    %plot((1/Lx)*(X(Ny/2,1:(Nx-1))+X(Ny/2,2:(Nx)))/2, -(1/Ulid)* ...
    %     (V(Ny/2,1:(Nx-1))+V(Ny/2,2:(Nx)))/2,'k-'), hold on
    %plot(Gdata(:,1), Gdata(:,2),'ko')

    figure(1), clf
subplot(2,3,1)
    [hC hC]=contourf(X(iny,inx),Y(iny,inx), C(iny,inx),30); set(hC, ...
                                                      'LineStyle','none'); ...
            colormap jet, shading flat, hold on
    streamslice( X(iny,inx),Y(iny,inx), U(iny,inx),V(iny,inx))

    colorbar
    axis equal, axis tight
    h = text(1.1*Lx, 1.1*Ly, 'C'); set(h,'Fontsize', 15)

    pause(0.1)
    hold on
       
 subplot(2,3,2)
    [hC hC]=contourf(X(iny,inx),Y(iny,inx), 1-C(iny,inx),30); set(hC, ...
                                                      'LineStyle','none'); ...
            colormap bone, shading flat, hold on
    streamslice( X(iny,inx),Y(iny,inx), U(iny,inx),V(iny,inx))
    colorbar
    axis equal, axis tight
    h = text(1.1*Lx, 1.1*Ly, 'C'); set(h,'Fontsize', 15)

    pause(0.1)
    hold on
    
  subplot(2,3,3)
    [hC hC]=contourf(X(iny,inx),Y(iny,inx), rho(iny,inx),30); set(hC, ...
                                                      'LineStyle','none'); ...
            colormap jet, shading flat, hold on
    colorbar
    axis equal, axis tight
    h = text(1.1*Lx, 1.1*Ly, '\rho (kg/m^3)'); set(h,'Fontsize', 15)

    pause(0.1)
    hold on
   
  subplot(2,3,4)
    [hC hC]=contourf(X(iny,inx),Y(iny,inx), T(iny,inx),30); set(hC, ...
                                                      'LineStyle','none'); ...
            colormap jet, shading flat, hold on
    colorbar
    axis equal, axis tight
    h = text(1.1*Lx, 1.1*Ly, 'T (K)'); set(h,'Fontsize', 15)
    
    pause(0.1)
    hold on
    
subplot(2,3,5)
    [hC hC]=contourf(X(iny,inx),Y(iny,inx), p(iny,inx),30); set(hC, ...
                                                      'LineStyle','none'); ...
            colormap jet, shading flat, hold on
    colorbar
    axis equal, axis tight
    h = text(1.1*Lx, 1.1*Ly, 'p (Pa)'); set(h,'Fontsize', 15)
    
    pause(0.1)
    hold on

subplot(2,3,6)
    [hC hC]=contourf(X(iny,inx),Y(iny,inx), ChemicalSource(iny,inx),30); set(hC, ...
                                                      'LineStyle','none'); ...
            colormap jet, shading flat, hold on
    colorbar
    axis equal, axis tight
    h = text(1.1*Lx, 1.1*Ly, '\omega'); set(h,'Fontsize', 15)
    
    pause(0.1)
    hold on
        

figure(2), clf    
subplot(1,3,1)
    [hC hC]=contourf(X(iny,inx),Y(iny,inx), U(iny,inx),30); set(hC, ...
                                                      'LineStyle','none'); ...
            hold on
    % 
    nor = 1./max(1e-6,sqrt(U(qiny,qinx).^2 + V(qiny,qinx).^2));
    
    quiver(X(qiny,qinx), Y(qiny,qinx),U(qiny,qinx).*nor,V(qiny,qinx).*nor,0.5,'k')
    colormap jet, shading flat
    axis equal, axis tight
    colorbar
    h = text(1.1*Lx, 1.1*Ly, 'U (m/s)'); set(h,'Fontsize', 15)
    
    pause(0.1)
    hold on
    
subplot(1,3,2)
    [hC hC]=contourf(X(iny,inx),Y(iny,inx), V(iny,inx),30); set(hC, ...
                                                      'LineStyle','none'); ...
            colormap jet, shading flat, hold on
    colorbar
    axis equal, axis tight
    h = text(1.1*Lx, 1.1*Ly, 'V (m/s)'); set(h,'Fontsize', 15)
    
    pause(0.1)
    hold on
 
subplot(1,3,3)
    [hC hC]=contourf(X(iny,inx),Y(iny,inx), kappa(iny,inx),30); set(hC, ...
                                                      'LineStyle','none'); ...
            colormap jet, shading flat, hold on
    colorbar
    axis equal, axis tight
    h = text(1.1*Lx, 1.1*Ly, '\kappa (1/m)'); set(h,'Fontsize', 15)
    
    pause(0.1)
    hold on
     
end